## Generated from gcsdk_gcmessages.proto
require "beefcake"

module Csgo

  module GCConnectionStatus
    GCConnectionStatus_HAVE_SESSION = 0
    GCConnectionStatus_GC_GOING_DOWN = 1
    GCConnectionStatus_NO_SESSION = 2
    GCConnectionStatus_NO_SESSION_IN_LOGON_QUEUE = 3
    GCConnectionStatus_NO_STEAM = 4
  end

  class CMsgSOIDOwner
    include Beefcake::Message
  end

  class CMsgSOSingleObject
    include Beefcake::Message
  end

  class CMsgSOMultipleObjects
    include Beefcake::Message

    class SingleObject
      include Beefcake::Message
    end
  end

  class CMsgSOCacheSubscribed
    include Beefcake::Message

    class SubscribedType
      include Beefcake::Message
    end
  end

  class CMsgSOCacheUnsubscribed
    include Beefcake::Message
  end

  class CMsgSOCacheSubscriptionCheck
    include Beefcake::Message
  end

  class CMsgSOCacheSubscriptionRefresh
    include Beefcake::Message
  end

  class CMsgSOCacheVersion
    include Beefcake::Message
  end

  class CMsgAccountDetails
    include Beefcake::Message
  end

  class CMsgGCMultiplexMessage
    include Beefcake::Message
  end

  class CMsgGCMultiplexMessage_Response
    include Beefcake::Message
  end

  class CGCToGCMsgMasterAck
    include Beefcake::Message
  end

  class CGCToGCMsgMasterAck_Response
    include Beefcake::Message
  end

  class CGCToGCMsgMasterStartupComplete
    include Beefcake::Message
  end

  class CGCToGCMsgRouted
    include Beefcake::Message
  end

  class CGCToGCMsgRoutedReply
    include Beefcake::Message
  end

  class CMsgGCUpdateSessionIP
    include Beefcake::Message
  end

  class CMsgGCRequestSessionIP
    include Beefcake::Message
  end

  class CMsgGCRequestSessionIPResponse
    include Beefcake::Message
  end

  class CMsgSOCacheHaveVersion
    include Beefcake::Message
  end

  class CMsgClientHello
    include Beefcake::Message
  end

  class CMsgServerHello
    include Beefcake::Message
  end

  class CMsgClientWelcome
    include Beefcake::Message

    class Location
      include Beefcake::Message
    end
  end

  class CMsgConnectionStatus
    include Beefcake::Message
  end

  class CWorkshop_PopulateItemDescriptions_Request
    include Beefcake::Message

    class SingleItemDescription
      include Beefcake::Message
    end

    class ItemDescriptionsLanguageBlock
      include Beefcake::Message
    end
  end

  class CWorkshop_GetContributors_Request
    include Beefcake::Message
  end

  class CWorkshop_GetContributors_Response
    include Beefcake::Message
  end

  class CWorkshop_SetItemPaymentRules_Request
    include Beefcake::Message

    class WorkshopItemPaymentRule
      include Beefcake::Message
    end

    class PartnerItemPaymentRule
      include Beefcake::Message
    end
  end

  class CWorkshop_SetItemPaymentRules_Response
    include Beefcake::Message
  end

  class CMsgSOIDOwner
    optional :type, :uint32, 1
    optional :id, :uint64, 2
  end

  class CMsgSOSingleObject
    optional :type_id, :int32, 2
    optional :object_data, :bytes, 3
    optional :version, :fixed64, 4
    optional :owner_soid, CMsgSOIDOwner, 5
  end

  class CMsgSOMultipleObjects

    class SingleObject
      optional :type_id, :int32, 1
      optional :object_data, :bytes, 2
    end
    repeated :objects_modified, CMsgSOMultipleObjects::SingleObject, 2
    optional :version, :fixed64, 3
    repeated :objects_added, CMsgSOMultipleObjects::SingleObject, 4
    repeated :objects_removed, CMsgSOMultipleObjects::SingleObject, 5
    optional :owner_soid, CMsgSOIDOwner, 6
  end

  class CMsgSOCacheSubscribed

    class SubscribedType
      optional :type_id, :int32, 1
      repeated :object_data, :bytes, 2
    end
    repeated :objects, CMsgSOCacheSubscribed::SubscribedType, 2
    optional :version, :fixed64, 3
    optional :owner_soid, CMsgSOIDOwner, 4
  end

  class CMsgSOCacheUnsubscribed
    optional :owner_soid, CMsgSOIDOwner, 2
  end

  class CMsgSOCacheSubscriptionCheck
    optional :version, :fixed64, 2
    optional :owner_soid, CMsgSOIDOwner, 3
  end

  class CMsgSOCacheSubscriptionRefresh
    optional :owner_soid, CMsgSOIDOwner, 2
  end

  class CMsgSOCacheVersion
    optional :version, :fixed64, 1
  end

  class CMsgAccountDetails
    optional :valid, :bool, 1
    optional :account_name, :string, 2
    optional :public_profile, :bool, 4
    optional :public_inventory, :bool, 5
    optional :vac_banned, :bool, 6
    optional :cyber_cafe, :bool, 7
    optional :school_account, :bool, 8
    optional :free_trial_account, :bool, 9
    optional :subscribed, :bool, 10
    optional :low_violence, :bool, 11
    optional :limited, :bool, 12
    optional :trusted, :bool, 13
    optional :package, :uint32, 14
    optional :time_cached, :fixed32, 15
    optional :account_locked, :bool, 16
    optional :community_banned, :bool, 17
    optional :trade_banned, :bool, 18
    optional :eligible_for_community_market, :bool, 19
  end

  class CMsgGCMultiplexMessage
    optional :msgtype, :uint32, 1
    optional :payload, :bytes, 2
    repeated :steamids, :fixed64, 3
    optional :replytogc, :bool, 4
  end

  class CMsgGCMultiplexMessage_Response
    optional :msgtype, :uint32, 1
  end

  class CGCToGCMsgMasterAck
    optional :dir_index, :uint32, 1
    optional :gc_type, :uint32, 2
  end

  class CGCToGCMsgMasterAck_Response
    optional :eresult, :int32, 1, :default => 2
  end

  class CGCToGCMsgMasterStartupComplete
  end

  class CGCToGCMsgRouted
    optional :msg_type, :uint32, 1
    optional :sender_id, :fixed64, 2
    optional :net_message, :bytes, 3
  end

  class CGCToGCMsgRoutedReply
    optional :msg_type, :uint32, 1
    optional :net_message, :bytes, 2
  end

  class CMsgGCUpdateSessionIP
    optional :steamid, :fixed64, 1
    optional :ip, :fixed32, 2
  end

  class CMsgGCRequestSessionIP
    optional :steamid, :fixed64, 1
  end

  class CMsgGCRequestSessionIPResponse
    optional :ip, :fixed32, 1
  end

  class CMsgSOCacheHaveVersion
    optional :soid, CMsgSOIDOwner, 1
    optional :version, :fixed64, 2
  end

  class CMsgClientHello
    optional :version, :uint32, 1
    repeated :socache_have_versions, CMsgSOCacheHaveVersion, 2
    optional :client_session_need, :uint32, 3
    optional :client_launcher, :uint32, 4
  end

  class CMsgServerHello
    optional :version, :uint32, 1
    repeated :socache_have_versions, CMsgSOCacheHaveVersion, 2
    optional :legacy_client_session_need, :uint32, 3
    optional :legacy_client_launcher, :uint32, 4
    optional :steamdatagram_port, :uint32, 5
  end

  class CMsgClientWelcome

    class Location
      optional :latitude, :float, 1
      optional :longitude, :float, 2
      optional :country, :string, 3
    end
    optional :version, :uint32, 1
    optional :game_data, :bytes, 2
    repeated :outofdate_subscribed_caches, CMsgSOCacheSubscribed, 3
    repeated :uptodate_subscribed_caches, CMsgSOCacheSubscriptionCheck, 4
    optional :location, CMsgClientWelcome::Location, 5
    optional :game_data2, :bytes, 6
    optional :rtime32_gc_welcome_timestamp, :uint32, 7
    optional :currency, :uint32, 8
  end

  class CMsgConnectionStatus
    optional :status, GCConnectionStatus, 1, :default => GCConnectionStatus::GCConnectionStatus_HAVE_SESSION
    optional :client_session_need, :uint32, 2
    optional :queue_position, :int32, 3
    optional :queue_size, :int32, 4
    optional :wait_seconds, :int32, 5
    optional :estimated_wait_seconds_remaining, :int32, 6
  end

  class CWorkshop_PopulateItemDescriptions_Request

    class SingleItemDescription
      optional :gameitemid, :uint32, 1
      optional :item_description, :string, 2
      optional :one_per_account, :bool, 3
    end

    class ItemDescriptionsLanguageBlock
      optional :language, :string, 1
      repeated :descriptions, CWorkshop_PopulateItemDescriptions_Request::SingleItemDescription, 2
    end
    optional :appid, :uint32, 1
    repeated :languages, CWorkshop_PopulateItemDescriptions_Request::ItemDescriptionsLanguageBlock, 2
  end

  class CWorkshop_GetContributors_Request
    optional :appid, :uint32, 1
    optional :gameitemid, :uint32, 2
  end

  class CWorkshop_GetContributors_Response
    repeated :contributors, :fixed64, 1
  end

  class CWorkshop_SetItemPaymentRules_Request

    class WorkshopItemPaymentRule
      optional :workshop_file_id, :uint64, 1
      optional :revenue_percentage, :float, 2
      optional :rule_description, :string, 3
    end

    class PartnerItemPaymentRule
      optional :account_id, :uint32, 1
      optional :revenue_percentage, :float, 2
      optional :rule_description, :string, 3
    end
    optional :appid, :uint32, 1
    optional :gameitemid, :uint32, 2
    repeated :associated_workshop_files, CWorkshop_SetItemPaymentRules_Request::WorkshopItemPaymentRule, 3
    repeated :partner_accounts, CWorkshop_SetItemPaymentRules_Request::PartnerItemPaymentRule, 4
  end

  class CWorkshop_SetItemPaymentRules_Response
  end
end
