## Generated from gcsystemmsgs.proto
require "beefcake"

module Csgo

  module EGCSystemMsg
    K_EGCMsgInvalid = 0
    K_EGCMsgMulti = 1
    K_EGCMsgGenericReply = 10
    K_EGCMsgSystemBase = 50
    K_EGCMsgAchievementAwarded = 51
    K_EGCMsgConCommand = 52
    K_EGCMsgStartPlaying = 53
    K_EGCMsgStopPlaying = 54
    K_EGCMsgStartGameserver = 55
    K_EGCMsgStopGameserver = 56
    K_EGCMsgWGRequest = 57
    K_EGCMsgWGResponse = 58
    K_EGCMsgGetUserGameStatsSchema = 59
    K_EGCMsgGetUserGameStatsSchemaResponse = 60
    K_EGCMsgGetUserStatsDEPRECATED = 61
    K_EGCMsgGetUserStatsResponse = 62
    K_EGCMsgAppInfoUpdated = 63
    K_EGCMsgValidateSession = 64
    K_EGCMsgValidateSessionResponse = 65
    K_EGCMsgLookupAccountFromInput = 66
    K_EGCMsgSendHTTPRequest = 67
    K_EGCMsgSendHTTPRequestResponse = 68
    K_EGCMsgPreTestSetup = 69
    K_EGCMsgRecordSupportAction = 70
    K_EGCMsgGetAccountDetails_DEPRECATED = 71
    K_EGCMsgReceiveInterAppMessage = 73
    K_EGCMsgFindAccounts = 74
    K_EGCMsgPostAlert = 75
    K_EGCMsgGetLicenses = 76
    K_EGCMsgGetUserStats = 77
    K_EGCMsgGetCommands = 78
    K_EGCMsgGetCommandsResponse = 79
    K_EGCMsgAddFreeLicense = 80
    K_EGCMsgAddFreeLicenseResponse = 81
    K_EGCMsgGetIPLocation = 82
    K_EGCMsgGetIPLocationResponse = 83
    K_EGCMsgSystemStatsSchema = 84
    K_EGCMsgGetSystemStats = 85
    K_EGCMsgGetSystemStatsResponse = 86
    K_EGCMsgSendEmail = 87
    K_EGCMsgSendEmailResponse = 88
    K_EGCMsgGetEmailTemplate = 89
    K_EGCMsgGetEmailTemplateResponse = 90
    K_EGCMsgGrantGuestPass = 91
    K_EGCMsgGrantGuestPassResponse = 92
    K_EGCMsgGetAccountDetails = 93
    K_EGCMsgGetAccountDetailsResponse = 94
    K_EGCMsgGetPersonaNames = 95
    K_EGCMsgGetPersonaNamesResponse = 96
    K_EGCMsgMultiplexMsg = 97
    K_EGCMsgMultiplexMsgResponse = 98
    K_EGCMsgWebAPIRegisterInterfaces = 101
    K_EGCMsgWebAPIJobRequest = 102
    K_EGCMsgWebAPIJobRequestHttpResponse = 104
    K_EGCMsgWebAPIJobRequestForwardResponse = 105
    K_EGCMsgMemCachedGet = 200
    K_EGCMsgMemCachedGetResponse = 201
    K_EGCMsgMemCachedSet = 202
    K_EGCMsgMemCachedDelete = 203
    K_EGCMsgMemCachedStats = 204
    K_EGCMsgMemCachedStatsResponse = 205
    K_EGCMsgMasterSetDirectory = 220
    K_EGCMsgMasterSetDirectoryResponse = 221
    K_EGCMsgMasterSetWebAPIRouting = 222
    K_EGCMsgMasterSetWebAPIRoutingResponse = 223
    K_EGCMsgMasterSetClientMsgRouting = 224
    K_EGCMsgMasterSetClientMsgRoutingResponse = 225
    K_EGCMsgSetOptions = 226
    K_EGCMsgSetOptionsResponse = 227
    K_EGCMsgSystemBase2 = 500
    K_EGCMsgGetPurchaseTrustStatus = 501
    K_EGCMsgGetPurchaseTrustStatusResponse = 502
    K_EGCMsgUpdateSession = 503
    K_EGCMsgGCAccountVacStatusChange = 504
    K_EGCMsgCheckFriendship = 505
    K_EGCMsgCheckFriendshipResponse = 506
    K_EGCMsgVacVerificationChange = 518
    K_EGCMsgAccountPhoneNumberChange = 519
  end

  module ESOMsg
    K_ESOMsg_Create = 21
    K_ESOMsg_Update = 22
    K_ESOMsg_Destroy = 23
    K_ESOMsg_CacheSubscribed = 24
    K_ESOMsg_CacheUnsubscribed = 25
    K_ESOMsg_UpdateMultiple = 26
    K_ESOMsg_CacheSubscriptionCheck = 27
    K_ESOMsg_CacheSubscriptionRefresh = 28
  end

  module EGCBaseClientMsg
    K_EMsgGCClientWelcome = 4004
    K_EMsgGCServerWelcome = 4005
    K_EMsgGCClientHello = 4006
    K_EMsgGCServerHello = 4007
    K_EMsgGCClientConnectionStatus = 4009
    K_EMsgGCServerConnectionStatus = 4010
  end

  module EGCToGCMsg
    K_EGCToGCMsgMasterAck = 150
    K_EGCToGCMsgMasterAckResponse = 151
    K_EGCToGCMsgRouted = 152
    K_EGCToGCMsgRoutedReply = 153
    K_EMsgUpdateSessionIP = 154
    K_EMsgRequestSessionIP = 155
    K_EMsgRequestSessionIPResponse = 156
    K_EGCToGCMsgMasterStartupComplete = 157
  end

  class CMsgGCHVacVerificationChange
    include Beefcake::Message
  end

  class CMsgGCHAccountPhoneNumberChange
    include Beefcake::Message
  end

  class CMsgGCHVacVerificationChange
    optional :steamid, :fixed64, 1
    optional :appid, :uint32, 2
    optional :is_verified, :bool, 3
  end

  class CMsgGCHAccountPhoneNumberChange
    optional :steamid, :fixed64, 1
    optional :appid, :uint32, 2
    optional :phone_id, :uint64, 3
    optional :is_verified, :bool, 4
    optional :is_identifying, :bool, 5
  end
end
