## Generated from steammessages_clientserver.proto
require "beefcake"

module Steamclient

  class CMsgClientHeartBeat
    include Beefcake::Message
  end

  class CMsgClientUDSP2PSessionStarted
    include Beefcake::Message
  end

  class CMsgClientUDSP2PSessionEnded
    include Beefcake::Message
  end

  class CMsgClientRegisterAuthTicketWithCM
    include Beefcake::Message
  end

  class CMsgClientTicketAuthComplete
    include Beefcake::Message
  end

  class CMsgClientLogon
    include Beefcake::Message
  end

  class CMsgClientLogonResponse
    include Beefcake::Message
  end

  class CMsgClientRequestWebAPIAuthenticateUserNonce
    include Beefcake::Message
  end

  class CMsgClientRequestWebAPIAuthenticateUserNonceResponse
    include Beefcake::Message
  end

  class CMsgClientLogOff
    include Beefcake::Message
  end

  class CMsgClientLoggedOff
    include Beefcake::Message
  end

  class CMsgClientCMList
    include Beefcake::Message
  end

  class CMsgClientP2PConnectionInfo
    include Beefcake::Message
  end

  class CMsgClientP2PConnectionFailInfo
    include Beefcake::Message
  end

  class CMsgClientGetAppOwnershipTicket
    include Beefcake::Message
  end

  class CMsgClientGetAppOwnershipTicketResponse
    include Beefcake::Message
  end

  class CMsgClientSessionToken
    include Beefcake::Message
  end

  class CMsgClientGameConnectTokens
    include Beefcake::Message
  end

  class CMsgGSServerType
    include Beefcake::Message
  end

  class CMsgGSStatusReply
    include Beefcake::Message
  end

  class CMsgGSPlayerList
    include Beefcake::Message

    class Player
      include Beefcake::Message
    end
  end

  class CMsgGSUserPlaying
    include Beefcake::Message
  end

  class CMsgGSDisconnectNotice
    include Beefcake::Message
  end

  class CMsgClientGamesPlayed
    include Beefcake::Message

    class GamePlayed
      include Beefcake::Message
    end
  end

  class CMsgGSApprove
    include Beefcake::Message
  end

  class CMsgGSDeny
    include Beefcake::Message
  end

  class CMsgGSKick
    include Beefcake::Message
  end

  class CMsgClientAuthList
    include Beefcake::Message
  end

  class CMsgClientAuthListAck
    include Beefcake::Message
  end

  class CMsgClientFriendsList
    include Beefcake::Message

    class Friend
      include Beefcake::Message
    end
  end

  class CMsgClientFriendsGroupsList
    include Beefcake::Message

    class FriendGroup
      include Beefcake::Message
    end

    class FriendGroupsMembership
      include Beefcake::Message
    end
  end

  class CMsgClientPlayerNicknameList
    include Beefcake::Message

    class PlayerNickname
      include Beefcake::Message
    end
  end

  class CMsgClientSetPlayerNickname
    include Beefcake::Message
  end

  class CMsgClientSetPlayerNicknameResponse
    include Beefcake::Message
  end

  class CMsgClientLicenseList
    include Beefcake::Message

    class License
      include Beefcake::Message
    end
  end

  class CMsgClientLBSSetScore
    include Beefcake::Message
  end

  class CMsgClientLBSSetScoreResponse
    include Beefcake::Message
  end

  class CMsgClientLBSSetUGC
    include Beefcake::Message
  end

  class CMsgClientLBSSetUGCResponse
    include Beefcake::Message
  end

  class CMsgClientLBSFindOrCreateLB
    include Beefcake::Message
  end

  class CMsgClientLBSFindOrCreateLBResponse
    include Beefcake::Message
  end

  class CMsgClientLBSGetLBEntries
    include Beefcake::Message
  end

  class CMsgClientLBSGetLBEntriesResponse
    include Beefcake::Message

    class Entry
      include Beefcake::Message
    end
  end

  class CMsgClientAccountInfo
    include Beefcake::Message
  end

  class CMsgClientAppMinutesPlayedData
    include Beefcake::Message

    class AppMinutesPlayedData
      include Beefcake::Message
    end
  end

  class CMsgClientIsLimitedAccount
    include Beefcake::Message
  end

  class CMsgClientRequestFriendData
    include Beefcake::Message
  end

  class CMsgClientChangeStatus
    include Beefcake::Message
  end

  class CMsgPersonaChangeResponse
    include Beefcake::Message
  end

  class CMsgClientPersonaState
    include Beefcake::Message

    class Friend
      include Beefcake::Message
    end
  end

  class CMsgClientFriendProfileInfo
    include Beefcake::Message
  end

  class CMsgClientFriendProfileInfoResponse
    include Beefcake::Message
  end

  class CMsgClientServerList
    include Beefcake::Message

    class Server
      include Beefcake::Message
    end
  end

  class CMsgClientRequestedClientStats
    include Beefcake::Message

    class StatsToSend
      include Beefcake::Message
    end
  end

  class CMsgClientStat2
    include Beefcake::Message

    class StatDetail
      include Beefcake::Message
    end
  end

  class CMsgClientMMSCreateLobby
    include Beefcake::Message
  end

  class CMsgClientMMSCreateLobbyResponse
    include Beefcake::Message
  end

  class CMsgClientMMSJoinLobby
    include Beefcake::Message
  end

  class CMsgClientMMSJoinLobbyResponse
    include Beefcake::Message

    class Member
      include Beefcake::Message
    end
  end

  class CMsgClientMMSLeaveLobby
    include Beefcake::Message
  end

  class CMsgClientMMSLeaveLobbyResponse
    include Beefcake::Message
  end

  class CMsgClientMMSGetLobbyList
    include Beefcake::Message

    class Filter
      include Beefcake::Message
    end
  end

  class CMsgClientMMSGetLobbyListResponse
    include Beefcake::Message

    class Lobby
      include Beefcake::Message
    end
  end

  class CMsgClientMMSSetLobbyData
    include Beefcake::Message
  end

  class CMsgClientMMSSetLobbyDataResponse
    include Beefcake::Message
  end

  class CMsgClientMMSGetLobbyData
    include Beefcake::Message
  end

  class CMsgClientMMSLobbyData
    include Beefcake::Message

    class Member
      include Beefcake::Message
    end
  end

  class CMsgClientMMSSendLobbyChatMsg
    include Beefcake::Message
  end

  class CMsgClientMMSLobbyChatMsg
    include Beefcake::Message
  end

  class CMsgClientMMSSetLobbyOwner
    include Beefcake::Message
  end

  class CMsgClientMMSSetLobbyOwnerResponse
    include Beefcake::Message
  end

  class CMsgClientMMSSetLobbyLinked
    include Beefcake::Message
  end

  class CMsgClientMMSSetLobbyGameServer
    include Beefcake::Message
  end

  class CMsgClientMMSLobbyGameServerSet
    include Beefcake::Message
  end

  class CMsgClientMMSUserJoinedLobby
    include Beefcake::Message
  end

  class CMsgClientMMSUserLeftLobby
    include Beefcake::Message
  end

  class CMsgClientMMSInviteToLobby
    include Beefcake::Message
  end

  class CMsgClientUDSInviteToGame
    include Beefcake::Message
  end

  class CMsgClientChatInvite
    include Beefcake::Message
  end

  class CMsgClientConnectionStats
    include Beefcake::Message

    class Stats_Logon
      include Beefcake::Message
    end

    class Stats_UDP
      include Beefcake::Message
    end

    class Stats_VConn
      include Beefcake::Message
    end
  end

  class CMsgClientServersAvailable
    include Beefcake::Message

    class Server_Types_Available
      include Beefcake::Message
    end
  end

  class CMsgClientGetUserStats
    include Beefcake::Message
  end

  class CMsgClientGetUserStatsResponse
    include Beefcake::Message

    class Stats
      include Beefcake::Message
    end

    class Achievement_Blocks
      include Beefcake::Message
    end
  end

  class CMsgClientStoreUserStatsResponse
    include Beefcake::Message

    class Stats_Failed_Validation
      include Beefcake::Message
    end
  end

  class CMsgClientStoreUserStats2
    include Beefcake::Message

    class Stats
      include Beefcake::Message
    end
  end

  class CMsgClientStatsUpdated
    include Beefcake::Message

    class Updated_Stats
      include Beefcake::Message
    end
  end

  class CMsgClientStoreUserStats
    include Beefcake::Message

    class Stats_To_Store
      include Beefcake::Message
    end
  end

  class CMsgClientGetClientDetails
    include Beefcake::Message
  end

  class CMsgClientReportOverlayDetourFailure
    include Beefcake::Message
  end

  class CMsgClientGetClientDetailsResponse
    include Beefcake::Message

    class Game
      include Beefcake::Message
    end
  end

  class CMsgClientGetClientAppList
    include Beefcake::Message
  end

  class CMsgClientGetClientAppListResponse
    include Beefcake::Message

    class App
      include Beefcake::Message

      class DLC
        include Beefcake::Message
      end
    end
  end

  class CMsgClientInstallClientApp
    include Beefcake::Message
  end

  class CMsgClientInstallClientAppResponse
    include Beefcake::Message
  end

  class CMsgClientUninstallClientApp
    include Beefcake::Message
  end

  class CMsgClientUninstallClientAppResponse
    include Beefcake::Message
  end

  class CMsgClientSetClientAppUpdateState
    include Beefcake::Message
  end

  class CMsgClientSetClientAppUpdateStateResponse
    include Beefcake::Message
  end

  class CMsgClientUFSUploadFileRequest
    include Beefcake::Message
  end

  class CMsgClientUFSUploadFileResponse
    include Beefcake::Message
  end

  class CMsgClientUFSUploadCommit
    include Beefcake::Message

    class File
      include Beefcake::Message
    end
  end

  class CMsgClientUFSUploadCommitResponse
    include Beefcake::Message

    class File
      include Beefcake::Message
    end
  end

  class CMsgClientUFSFileChunk
    include Beefcake::Message
  end

  class CMsgClientUFSTransferHeartbeat
    include Beefcake::Message
  end

  class CMsgClientUFSUploadFileFinished
    include Beefcake::Message
  end

  class CMsgClientUFSDeleteFileRequest
    include Beefcake::Message
  end

  class CMsgClientUFSDeleteFileResponse
    include Beefcake::Message
  end

  class CMsgClientUFSGetFileListForApp
    include Beefcake::Message
  end

  class CMsgClientUFSGetFileListForAppResponse
    include Beefcake::Message

    class File
      include Beefcake::Message
    end
  end

  class CMsgClientUFSDownloadRequest
    include Beefcake::Message
  end

  class CMsgClientUFSDownloadResponse
    include Beefcake::Message
  end

  class CMsgClientUFSLoginRequest
    include Beefcake::Message
  end

  class CMsgClientUFSLoginResponse
    include Beefcake::Message
  end

  class CMsgClientRequestEncryptedAppTicket
    include Beefcake::Message
  end

  class CMsgClientRequestEncryptedAppTicketResponse
    include Beefcake::Message
  end

  class CMsgClientWalletInfoUpdate
    include Beefcake::Message
  end

  class CMsgClientAppInfoUpdate
    include Beefcake::Message
  end

  class CMsgClientAppInfoChanges
    include Beefcake::Message
  end

  class CMsgClientAppInfoRequest
    include Beefcake::Message

    class App
      include Beefcake::Message
    end
  end

  class CMsgClientAppInfoResponse
    include Beefcake::Message

    class App
      include Beefcake::Message

      class Section
        include Beefcake::Message
      end
    end
  end

  class CMsgClientPackageInfoRequest
    include Beefcake::Message
  end

  class CMsgClientPackageInfoResponse
    include Beefcake::Message

    class Package
      include Beefcake::Message
    end
  end

  class CMsgClientPICSChangesSinceRequest
    include Beefcake::Message
  end

  class CMsgClientPICSChangesSinceResponse
    include Beefcake::Message

    class PackageChange
      include Beefcake::Message
    end

    class AppChange
      include Beefcake::Message
    end
  end

  class CMsgClientPICSProductInfoRequest
    include Beefcake::Message

    class AppInfo
      include Beefcake::Message
    end

    class PackageInfo
      include Beefcake::Message
    end
  end

  class CMsgClientPICSProductInfoResponse
    include Beefcake::Message

    class AppInfo
      include Beefcake::Message
    end

    class PackageInfo
      include Beefcake::Message
    end
  end

  class CMsgClientPICSAccessTokenRequest
    include Beefcake::Message
  end

  class CMsgClientPICSAccessTokenResponse
    include Beefcake::Message

    class PackageToken
      include Beefcake::Message
    end

    class AppToken
      include Beefcake::Message
    end
  end

  class CMsgClientUFSGetUGCDetails
    include Beefcake::Message
  end

  class CMsgClientUFSGetUGCDetailsResponse
    include Beefcake::Message
  end

  class CMsgClientUFSGetSingleFileInfo
    include Beefcake::Message
  end

  class CMsgClientUFSGetSingleFileInfoResponse
    include Beefcake::Message
  end

  class CMsgClientUFSShareFile
    include Beefcake::Message
  end

  class CMsgClientUFSShareFileResponse
    include Beefcake::Message
  end

  class CMsgClientNewLoginKey
    include Beefcake::Message
  end

  class CMsgClientNewLoginKeyAccepted
    include Beefcake::Message
  end

  class CMsgClientAMGetClanOfficers
    include Beefcake::Message
  end

  class CMsgClientAMGetClanOfficersResponse
    include Beefcake::Message
  end

  class CMsgClientAMGetPersonaNameHistory
    include Beefcake::Message

    class IdInstance
      include Beefcake::Message
    end
  end

  class CMsgClientAMGetPersonaNameHistoryResponse
    include Beefcake::Message

    class NameTableInstance
      include Beefcake::Message

      class NameInstance
        include Beefcake::Message
      end
    end
  end

  class CMsgClientDeregisterWithServer
    include Beefcake::Message
  end

  class CMsgClientClanState
    include Beefcake::Message

    class NameInfo
      include Beefcake::Message
    end

    class UserCounts
      include Beefcake::Message
    end

    class Event
      include Beefcake::Message
    end
  end

  class CMsgClientFriendMsg
    include Beefcake::Message
  end

  class CMsgClientFriendMsgIncoming
    include Beefcake::Message
  end

  class CMsgClientAddFriend
    include Beefcake::Message
  end

  class CMsgClientAddFriendResponse
    include Beefcake::Message
  end

  class CMsgClientRemoveFriend
    include Beefcake::Message
  end

  class CMsgClientHideFriend
    include Beefcake::Message
  end

  class CMsgClientHeartBeat
  end

  class CMsgClientUDSP2PSessionStarted
    optional :steamid_remote, :fixed64, 1
    optional :appid, :int32, 2
  end

  class CMsgClientUDSP2PSessionEnded
    optional :steamid_remote, :fixed64, 1
    optional :appid, :int32, 2
    optional :session_length_sec, :int32, 3
    optional :session_error, :int32, 4
    optional :nattype, :int32, 5
    optional :bytes_recv, :int32, 6
    optional :bytes_sent, :int32, 7
    optional :bytes_sent_relay, :int32, 8
    optional :bytes_recv_relay, :int32, 9
    optional :time_to_connect_ms, :int32, 10
  end

  class CMsgClientRegisterAuthTicketWithCM
    optional :protocol_version, :uint32, 1
    optional :ticket, :bytes, 3
    optional :client_instance_id, :uint64, 4
  end

  class CMsgClientTicketAuthComplete
    optional :steam_id, :fixed64, 1
    optional :game_id, :fixed64, 2
    optional :estate, :uint32, 3
    optional :eauth_session_response, :uint32, 4
    optional :DEPRECATED_ticket, :bytes, 5
    optional :ticket_crc, :uint32, 6
    optional :ticket_sequence, :uint32, 7
    optional :owner_steam_id, :fixed64, 8
  end

  class CMsgClientLogon
    optional :protocol_version, :uint32, 1
    optional :obfustucated_private_ip, :uint32, 2
    optional :cell_id, :uint32, 3
    optional :last_session_id, :uint32, 4
    optional :client_package_version, :uint32, 5
    optional :client_language, :string, 6
    optional :client_os_type, :uint32, 7
    optional :should_remember_password, :bool, 8, :default => false
    optional :wine_version, :string, 9
    optional :ping_ms_from_cell_search, :uint32, 10
    optional :public_ip, :uint32, 20
    optional :qos_level, :uint32, 21
    optional :client_supplied_steam_id, :fixed64, 22
    optional :machine_id, :bytes, 30
    optional :launcher_type, :uint32, 31, :default => 0
    optional :ui_mode, :uint32, 32, :default => 0
    optional :steam2_auth_ticket, :bytes, 41
    optional :email_address, :string, 42
    optional :rtime32_account_creation, :fixed32, 43
    optional :account_name, :string, 50
    optional :password, :string, 51
    optional :game_server_token, :string, 52
    optional :login_key, :string, 60
    optional :was_converted_deprecated_msg, :bool, 70, :default => false
    optional :anon_user_target_account_name, :string, 80
    optional :resolved_user_steam_id, :fixed64, 81
    optional :eresult_sentryfile, :int32, 82
    optional :sha_sentryfile, :bytes, 83
    optional :auth_code, :string, 84
    optional :otp_type, :int32, 85
    optional :otp_value, :uint32, 86
    optional :otp_identifier, :string, 87
    optional :steam2_ticket_request, :bool, 88
    optional :sony_psn_ticket, :bytes, 90
    optional :sony_psn_service_id, :string, 91
    optional :create_new_psn_linked_account_if_needed, :bool, 92, :default => false
    optional :sony_psn_name, :string, 93
    optional :game_server_app_id, :int32, 94
    optional :steamguard_dont_remember_computer, :bool, 95
    optional :machine_name, :string, 96
    optional :machine_name_userchosen, :string, 97
    optional :country_override, :string, 98
    optional :is_steam_box, :bool, 99
    optional :client_instance_id, :uint64, 100
    optional :two_factor_code, :string, 101
    optional :supports_rate_limit_response, :bool, 102
  end

  class CMsgClientLogonResponse
    optional :eresult, :int32, 1, :default => 2
    optional :out_of_game_heartbeat_seconds, :int32, 2
    optional :in_game_heartbeat_seconds, :int32, 3
    optional :public_ip, :uint32, 4
    optional :rtime32_server_time, :fixed32, 5
    optional :account_flags, :uint32, 6
    optional :cell_id, :uint32, 7
    optional :email_domain, :string, 8
    optional :steam2_ticket, :bytes, 9
    optional :eresult_extended, :int32, 10
    optional :webapi_authenticate_user_nonce, :string, 11
    optional :cell_id_ping_threshold, :uint32, 12
    optional :use_pics, :bool, 13
    optional :vanity_url, :string, 14
    optional :client_supplied_steamid, :fixed64, 20
    optional :ip_country_code, :string, 21
    optional :parental_settings, :bytes, 22
    optional :parental_setting_signature, :bytes, 23
    optional :count_loginfailures_to_migrate, :int32, 24
    optional :count_disconnects_to_migrate, :int32, 25
    optional :ogs_data_report_time_window, :int32, 26
    optional :client_instance_id, :uint64, 27
  end

  class CMsgClientRequestWebAPIAuthenticateUserNonce
  end

  class CMsgClientRequestWebAPIAuthenticateUserNonceResponse
    optional :eresult, :int32, 1, :default => 2
    optional :webapi_authenticate_user_nonce, :string, 11
  end

  class CMsgClientLogOff
  end

  class CMsgClientLoggedOff
    optional :eresult, :int32, 1, :default => 2
  end

  class CMsgClientCMList
    repeated :cm_addresses, :uint32, 1
    repeated :cm_ports, :uint32, 2
  end

  class CMsgClientP2PConnectionInfo
    optional :steam_id_dest, :fixed64, 1
    optional :steam_id_src, :fixed64, 2
    optional :app_id, :uint32, 3
    optional :candidate, :bytes, 4
  end

  class CMsgClientP2PConnectionFailInfo
    optional :steam_id_dest, :fixed64, 1
    optional :steam_id_src, :fixed64, 2
    optional :app_id, :uint32, 3
    optional :ep2p_session_error, :uint32, 4
  end

  class CMsgClientGetAppOwnershipTicket
    optional :app_id, :uint32, 1
  end

  class CMsgClientGetAppOwnershipTicketResponse
    optional :eresult, :uint32, 1, :default => 2
    optional :app_id, :uint32, 2
    optional :ticket, :bytes, 3
  end

  class CMsgClientSessionToken
    optional :token, :uint64, 1
  end

  class CMsgClientGameConnectTokens
    optional :max_tokens_to_keep, :uint32, 1, :default => 10
    repeated :tokens, :bytes, 2
  end

  class CMsgGSServerType
    optional :app_id_served, :uint32, 1
    optional :flags, :uint32, 2
    optional :game_ip_address, :uint32, 3
    optional :game_port, :uint32, 4
    optional :game_dir, :string, 5
    optional :game_version, :string, 6
    optional :game_query_port, :uint32, 7
  end

  class CMsgGSStatusReply
    optional :is_secure, :bool, 1
  end

  class CMsgGSPlayerList

    class Player
      optional :steam_id, :uint64, 1
      optional :public_ip, :uint32, 2
      optional :token, :bytes, 3
    end
    repeated :players, CMsgGSPlayerList::Player, 1
  end

  class CMsgGSUserPlaying
    optional :steam_id, :fixed64, 1
    optional :public_ip, :uint32, 2
    optional :token, :bytes, 3
  end

  class CMsgGSDisconnectNotice
    optional :steam_id, :fixed64, 1
  end

  class CMsgClientGamesPlayed

    class GamePlayed
      optional :steam_id_gs, :uint64, 1
      optional :game_id, :fixed64, 2
      optional :game_ip_address, :uint32, 3
      optional :game_port, :uint32, 4
      optional :is_secure, :bool, 5
      optional :token, :bytes, 6
      optional :game_extra_info, :string, 7
      optional :game_data_blob, :bytes, 8
      optional :process_id, :uint32, 9
      optional :streaming_provider_id, :uint32, 10
      optional :game_flags, :uint32, 11
      optional :owner_id, :uint32, 12
      optional :vr_hmd_vendor, :string, 13
      optional :vr_hmd_model, :string, 14
      optional :launch_option_type, :uint32, 15, :default => 0
      optional :primary_controller_type, :int32, 16, :default => -1
      optional :primary_steam_controller_serial, :string, 17
      optional :total_steam_controller_count, :uint32, 18, :default => 0
      optional :total_non_steam_controller_count, :uint32, 19, :default => 0
      optional :controller_workshop_file_id, :uint64, 20, :default => 0
    end
    repeated :games_played, CMsgClientGamesPlayed::GamePlayed, 1
    optional :client_os_type, :uint32, 2
  end

  class CMsgGSApprove
    optional :steam_id, :fixed64, 1
    optional :owner_steam_id, :fixed64, 2
  end

  class CMsgGSDeny
    optional :steam_id, :fixed64, 1
    optional :edeny_reason, :int32, 2
    optional :deny_string, :string, 3
  end

  class CMsgGSKick
    optional :steam_id, :fixed64, 1
    optional :edeny_reason, :int32, 2
  end

  class CMsgClientAuthList
    optional :tokens_left, :uint32, 1
    optional :last_request_seq, :uint32, 2
    optional :last_request_seq_from_server, :uint32, 3
    repeated :tickets, CMsgAuthTicket, 4
    repeated :app_ids, :uint32, 5
    optional :message_sequence, :uint32, 6
  end

  class CMsgClientAuthListAck
    repeated :ticket_crc, :uint32, 1
    repeated :app_ids, :uint32, 2
    optional :message_sequence, :uint32, 3
  end

  class CMsgClientFriendsList

    class Friend
      optional :ulfriendid, :fixed64, 1
      optional :efriendrelationship, :uint32, 2
    end
    optional :bincremental, :bool, 1
    repeated :friends, CMsgClientFriendsList::Friend, 2
    optional :max_friend_count, :uint32, 3
    optional :active_friend_count, :uint32, 4
    optional :friends_limit_hit, :bool, 5
  end

  class CMsgClientFriendsGroupsList

    class FriendGroup
      optional :nGroupID, :int32, 1
      optional :strGroupName, :string, 2
    end

    class FriendGroupsMembership
      optional :ulSteamID, :fixed64, 1
      optional :nGroupID, :int32, 2
    end
    optional :bremoval, :bool, 1
    optional :bincremental, :bool, 2
    repeated :friendGroups, CMsgClientFriendsGroupsList::FriendGroup, 3
    repeated :memberships, CMsgClientFriendsGroupsList::FriendGroupsMembership, 4
  end

  class CMsgClientPlayerNicknameList

    class PlayerNickname
      optional :steamid, :fixed64, 1
      optional :nickname, :string, 3
    end
    optional :removal, :bool, 1
    optional :incremental, :bool, 2
    repeated :nicknames, CMsgClientPlayerNicknameList::PlayerNickname, 3
  end

  class CMsgClientSetPlayerNickname
    optional :steamid, :fixed64, 1
    optional :nickname, :string, 2
  end

  class CMsgClientSetPlayerNicknameResponse
    optional :eresult, :uint32, 1
  end

  class CMsgClientLicenseList

    class License
      optional :package_id, :uint32, 1
      optional :time_created, :fixed32, 2
      optional :time_next_process, :fixed32, 3
      optional :minute_limit, :int32, 4
      optional :minutes_used, :int32, 5
      optional :payment_method, :uint32, 6
      optional :flags, :uint32, 7
      optional :purchase_country_code, :string, 8
      optional :license_type, :uint32, 9
      optional :territory_code, :int32, 10
      optional :change_number, :int32, 11
      optional :owner_id, :uint32, 12
      optional :initial_period, :uint32, 13
      optional :initial_time_unit, :uint32, 14
      optional :renewal_period, :uint32, 15
      optional :renewal_time_unit, :uint32, 16
    end
    optional :eresult, :int32, 1, :default => 2
    repeated :licenses, CMsgClientLicenseList::License, 2
  end

  class CMsgClientLBSSetScore
    optional :app_id, :uint32, 1
    optional :leaderboard_id, :int32, 2
    optional :score, :int32, 3
    optional :details, :bytes, 4
    optional :upload_score_method, :int32, 5
  end

  class CMsgClientLBSSetScoreResponse
    optional :eresult, :int32, 1, :default => 2
    optional :leaderboard_entry_count, :int32, 2
    optional :score_changed, :bool, 3
    optional :global_rank_previous, :int32, 4
    optional :global_rank_new, :int32, 5
  end

  class CMsgClientLBSSetUGC
    optional :app_id, :uint32, 1
    optional :leaderboard_id, :int32, 2
    optional :ugc_id, :fixed64, 3
  end

  class CMsgClientLBSSetUGCResponse
    optional :eresult, :int32, 1, :default => 2
  end

  class CMsgClientLBSFindOrCreateLB
    optional :app_id, :uint32, 1
    optional :leaderboard_sort_method, :int32, 2
    optional :leaderboard_display_type, :int32, 3
    optional :create_if_not_found, :bool, 4
    optional :leaderboard_name, :string, 5
  end

  class CMsgClientLBSFindOrCreateLBResponse
    optional :eresult, :int32, 1, :default => 2
    optional :leaderboard_id, :int32, 2
    optional :leaderboard_entry_count, :int32, 3
    optional :leaderboard_sort_method, :int32, 4, :default => 0
    optional :leaderboard_display_type, :int32, 5, :default => 0
    optional :leaderboard_name, :string, 6
  end

  class CMsgClientLBSGetLBEntries
    optional :app_id, :int32, 1
    optional :leaderboard_id, :int32, 2
    optional :range_start, :int32, 3
    optional :range_end, :int32, 4
    optional :leaderboard_data_request, :int32, 5
    repeated :steamids, :fixed64, 6
  end

  class CMsgClientLBSGetLBEntriesResponse

    class Entry
      optional :steam_id_user, :fixed64, 1
      optional :global_rank, :int32, 2
      optional :score, :int32, 3
      optional :details, :bytes, 4
      optional :ugc_id, :fixed64, 5
    end
    optional :eresult, :int32, 1, :default => 2
    optional :leaderboard_entry_count, :int32, 2
    repeated :entries, CMsgClientLBSGetLBEntriesResponse::Entry, 3
  end

  class CMsgClientAccountInfo
    optional :persona_name, :string, 1
    optional :ip_country, :string, 2
    optional :count_authed_computers, :int32, 5
    optional :account_flags, :uint32, 7
    optional :facebook_id, :uint64, 8
    optional :facebook_name, :string, 9
    optional :steamguard_notify_newmachines, :bool, 14
    optional :steamguard_machine_name_user_chosen, :string, 15
    optional :is_phone_verified, :bool, 16
    optional :two_factor_state, :uint32, 17
    optional :is_phone_identifying, :bool, 18
    optional :is_phone_needing_reverify, :bool, 19
  end

  class CMsgClientAppMinutesPlayedData

    class AppMinutesPlayedData
      optional :app_id, :uint32, 1
      optional :forever, :int32, 2
      optional :last_two_weeks, :int32, 3
    end
    repeated :minutes_played, CMsgClientAppMinutesPlayedData::AppMinutesPlayedData, 1
  end

  class CMsgClientIsLimitedAccount
    optional :bis_limited_account, :bool, 1
    optional :bis_community_banned, :bool, 2
    optional :bis_locked_account, :bool, 3
    optional :bis_limited_account_allowed_to_invite_friends, :bool, 4
  end

  class CMsgClientRequestFriendData
    optional :persona_state_requested, :uint32, 1
    repeated :friends, :fixed64, 2
  end

  class CMsgClientChangeStatus
    optional :persona_state, :uint32, 1
    optional :player_name, :string, 2
    optional :is_auto_generated_name, :bool, 3
    optional :high_priority, :bool, 4
    optional :persona_set_by_user, :bool, 5
    optional :persona_state_flags, :uint32, 6, :default => 0
  end

  class CMsgPersonaChangeResponse
    optional :result, :uint32, 1
    optional :player_name, :string, 2
  end

  class CMsgClientPersonaState

    class Friend
      optional :friendid, :fixed64, 1
      optional :persona_state, :uint32, 2
      optional :game_played_app_id, :uint32, 3
      optional :game_server_ip, :uint32, 4
      optional :game_server_port, :uint32, 5
      optional :persona_state_flags, :uint32, 6
      optional :online_session_instances, :uint32, 7
      optional :published_instance_id, :uint32, 8
      optional :persona_set_by_user, :bool, 10
      optional :player_name, :string, 15
      optional :query_port, :uint32, 20
      optional :steamid_source, :fixed64, 25
      optional :avatar_hash, :bytes, 31
      optional :last_logoff, :uint32, 45
      optional :last_logon, :uint32, 46
      optional :clan_rank, :uint32, 50
      optional :game_name, :string, 55
      optional :gameid, :fixed64, 56
      optional :game_data_blob, :bytes, 60
      optional :clan_tag, :string, 65
      optional :facebook_name, :string, 66
      optional :facebook_id, :uint64, 67
    end
    optional :status_flags, :uint32, 1
    repeated :friends, CMsgClientPersonaState::Friend, 2
  end

  class CMsgClientFriendProfileInfo
    optional :steamid_friend, :fixed64, 1
  end

  class CMsgClientFriendProfileInfoResponse
    optional :eresult, :int32, 1, :default => 2
    optional :steamid_friend, :fixed64, 2
    optional :time_created, :uint32, 3
    optional :real_name, :string, 4
    optional :city_name, :string, 5
    optional :state_name, :string, 6
    optional :country_name, :string, 7
    optional :headline, :string, 8
    optional :summary, :string, 9
  end

  class CMsgClientServerList

    class Server
      optional :server_type, :uint32, 1
      optional :server_ip, :uint32, 2
      optional :server_port, :uint32, 3
    end
    repeated :servers, CMsgClientServerList::Server, 1
  end

  class CMsgClientRequestedClientStats

    class StatsToSend
      optional :client_stat, :uint32, 1
      optional :stat_aggregate_method, :uint32, 2
    end
    repeated :stats_to_send, CMsgClientRequestedClientStats::StatsToSend, 1
  end

  class CMsgClientStat2

    class StatDetail
      optional :client_stat, :uint32, 1
      optional :ll_value, :int64, 2
      optional :time_of_day, :uint32, 3
      optional :cell_id, :uint32, 4
      optional :depot_id, :uint32, 5
      optional :app_id, :uint32, 6
    end
    repeated :stat_detail, CMsgClientStat2::StatDetail, 1
  end

  class CMsgClientMMSCreateLobby
    optional :app_id, :uint32, 1
    optional :max_members, :int32, 2
    optional :lobby_type, :int32, 3
    optional :lobby_flags, :int32, 4
    optional :cell_id, :uint32, 5
    optional :public_ip, :uint32, 6
    optional :metadata, :bytes, 7
    optional :persona_name_owner, :string, 8
  end

  class CMsgClientMMSCreateLobbyResponse
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :eresult, :int32, 3, :default => 2
  end

  class CMsgClientMMSJoinLobby
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :persona_name, :string, 3
  end

  class CMsgClientMMSJoinLobbyResponse

    class Member
      optional :steam_id, :fixed64, 1
      optional :persona_name, :string, 2
      optional :metadata, :bytes, 3
    end
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :chat_room_enter_response, :int32, 3
    optional :max_members, :int32, 4
    optional :lobby_type, :int32, 5
    optional :lobby_flags, :int32, 6
    optional :steam_id_owner, :fixed64, 7
    optional :metadata, :bytes, 8
    repeated :members, CMsgClientMMSJoinLobbyResponse::Member, 9
  end

  class CMsgClientMMSLeaveLobby
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
  end

  class CMsgClientMMSLeaveLobbyResponse
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :eresult, :int32, 3, :default => 2
  end

  class CMsgClientMMSGetLobbyList

    class Filter
      optional :key, :string, 1
      optional :value, :string, 2
      optional :comparision, :int32, 3
      optional :filter_type, :int32, 4
    end
    optional :app_id, :uint32, 1
    optional :num_lobbies_requested, :int32, 3
    optional :cell_id, :uint32, 4
    optional :public_ip, :uint32, 5
    repeated :filters, CMsgClientMMSGetLobbyList::Filter, 6
  end

  class CMsgClientMMSGetLobbyListResponse

    class Lobby
      optional :steam_id, :fixed64, 1
      optional :max_members, :int32, 2
      optional :lobby_type, :int32, 3
      optional :lobby_flags, :int32, 4
      optional :metadata, :bytes, 5
      optional :num_members, :int32, 6
      optional :distance, :float, 7
      optional :weight, :int64, 8
    end
    optional :app_id, :uint32, 1
    optional :eresult, :int32, 3, :default => 2
    repeated :lobbies, CMsgClientMMSGetLobbyListResponse::Lobby, 4
  end

  class CMsgClientMMSSetLobbyData
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :steam_id_member, :fixed64, 3
    optional :max_members, :int32, 4
    optional :lobby_type, :int32, 5
    optional :lobby_flags, :int32, 6
    optional :metadata, :bytes, 7
  end

  class CMsgClientMMSSetLobbyDataResponse
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :eresult, :int32, 3, :default => 2
  end

  class CMsgClientMMSGetLobbyData
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
  end

  class CMsgClientMMSLobbyData

    class Member
      optional :steam_id, :fixed64, 1
      optional :persona_name, :string, 2
      optional :metadata, :bytes, 3
    end
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :num_members, :int32, 3
    optional :max_members, :int32, 4
    optional :lobby_type, :int32, 5
    optional :lobby_flags, :int32, 6
    optional :steam_id_owner, :fixed64, 7
    optional :metadata, :bytes, 8
    repeated :members, CMsgClientMMSLobbyData::Member, 9
    optional :lobby_cellid, :uint32, 10
  end

  class CMsgClientMMSSendLobbyChatMsg
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :steam_id_target, :fixed64, 3
    optional :lobby_message, :bytes, 4
  end

  class CMsgClientMMSLobbyChatMsg
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :steam_id_sender, :fixed64, 3
    optional :lobby_message, :bytes, 4
  end

  class CMsgClientMMSSetLobbyOwner
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :steam_id_new_owner, :fixed64, 3
  end

  class CMsgClientMMSSetLobbyOwnerResponse
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :eresult, :int32, 3, :default => 2
  end

  class CMsgClientMMSSetLobbyLinked
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :steam_id_lobby2, :fixed64, 3
  end

  class CMsgClientMMSSetLobbyGameServer
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :game_server_ip, :uint32, 3
    optional :game_server_port, :uint32, 4
    optional :game_server_steam_id, :fixed64, 5
  end

  class CMsgClientMMSLobbyGameServerSet
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :game_server_ip, :uint32, 3
    optional :game_server_port, :uint32, 4
    optional :game_server_steam_id, :fixed64, 5
  end

  class CMsgClientMMSUserJoinedLobby
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :steam_id_user, :fixed64, 3
    optional :persona_name, :string, 4
  end

  class CMsgClientMMSUserLeftLobby
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :steam_id_user, :fixed64, 3
    optional :persona_name, :string, 4
  end

  class CMsgClientMMSInviteToLobby
    optional :app_id, :uint32, 1
    optional :steam_id_lobby, :fixed64, 2
    optional :steam_id_user_invited, :fixed64, 3
  end

  class CMsgClientUDSInviteToGame
    optional :steam_id_dest, :fixed64, 1
    optional :steam_id_src, :fixed64, 2
    optional :connect_string, :string, 3
  end

  class CMsgClientChatInvite
    optional :steam_id_invited, :fixed64, 1
    optional :steam_id_chat, :fixed64, 2
    optional :steam_id_patron, :fixed64, 3
    optional :chatroom_type, :int32, 4
    optional :steam_id_friend_chat, :fixed64, 5
    optional :chat_name, :string, 6
    optional :game_id, :fixed64, 7
  end

  class CMsgClientConnectionStats

    class Stats_Logon
      optional :connect_attempts, :int32, 1
      optional :connect_successes, :int32, 2
      optional :connect_failures, :int32, 3
      optional :connections_dropped, :int32, 4
      optional :seconds_running, :uint32, 5
      optional :msec_tologonthistime, :uint32, 6
      optional :count_bad_cms, :uint32, 7
    end

    class Stats_UDP
      optional :pkts_sent, :uint64, 1
      optional :bytes_sent, :uint64, 2
      optional :pkts_recv, :uint64, 3
      optional :pkts_processed, :uint64, 4
      optional :bytes_recv, :uint64, 5
    end

    class Stats_VConn
      optional :connections_udp, :uint32, 1
      optional :connections_tcp, :uint32, 2
      optional :stats_udp, CMsgClientConnectionStats::Stats_UDP, 3
      optional :pkts_abandoned, :uint64, 4
      optional :conn_req_received, :uint64, 5
      optional :pkts_resent, :uint64, 6
      optional :msgs_sent, :uint64, 7
      optional :msgs_sent_failed, :uint64, 8
      optional :msgs_recv, :uint64, 9
      optional :datagrams_sent, :uint64, 10
      optional :datagrams_recv, :uint64, 11
      optional :bad_pkts_recv, :uint64, 12
      optional :unknown_conn_pkts_recv, :uint64, 13
      optional :missed_pkts_recv, :uint64, 14
      optional :dup_pkts_recv, :uint64, 15
      optional :failed_connect_challenges, :uint64, 16
      optional :micro_sec_avg_latency, :uint32, 17
      optional :micro_sec_min_latency, :uint32, 18
      optional :micro_sec_max_latency, :uint32, 19
      optional :mem_pool_msg_in_use, :uint32, 20
    end
    optional :stats_logon, CMsgClientConnectionStats::Stats_Logon, 1
    optional :stats_vconn, CMsgClientConnectionStats::Stats_VConn, 2
  end

  class CMsgClientServersAvailable

    class Server_Types_Available
      optional :server, :uint32, 1
      optional :changed, :bool, 2
    end
    repeated :server_types_available, CMsgClientServersAvailable::Server_Types_Available, 1
    optional :server_type_for_auth_services, :uint32, 2
  end

  class CMsgClientGetUserStats
    optional :game_id, :fixed64, 1
    optional :crc_stats, :uint32, 2
    optional :schema_local_version, :int32, 3
    optional :steam_id_for_user, :fixed64, 4
  end

  class CMsgClientGetUserStatsResponse

    class Stats
      optional :stat_id, :uint32, 1
      optional :stat_value, :uint32, 2
    end

    class Achievement_Blocks
      optional :achievement_id, :uint32, 1
      repeated :unlock_time, :fixed32, 2
    end
    optional :game_id, :fixed64, 1
    optional :eresult, :int32, 2, :default => 2
    optional :crc_stats, :uint32, 3
    optional :schema, :bytes, 4
    repeated :stats, CMsgClientGetUserStatsResponse::Stats, 5
    repeated :achievement_blocks, CMsgClientGetUserStatsResponse::Achievement_Blocks, 6
  end

  class CMsgClientStoreUserStatsResponse

    class Stats_Failed_Validation
      optional :stat_id, :uint32, 1
      optional :reverted_stat_value, :uint32, 2
    end
    optional :game_id, :fixed64, 1
    optional :eresult, :int32, 2, :default => 2
    optional :crc_stats, :uint32, 3
    repeated :stats_failed_validation, CMsgClientStoreUserStatsResponse::Stats_Failed_Validation, 4
    optional :stats_out_of_date, :bool, 5
  end

  class CMsgClientStoreUserStats2

    class Stats
      optional :stat_id, :uint32, 1
      optional :stat_value, :uint32, 2
    end
    optional :game_id, :fixed64, 1
    optional :settor_steam_id, :fixed64, 2
    optional :settee_steam_id, :fixed64, 3
    optional :crc_stats, :uint32, 4
    optional :explicit_reset, :bool, 5
    repeated :stats, CMsgClientStoreUserStats2::Stats, 6
  end

  class CMsgClientStatsUpdated

    class Updated_Stats
      optional :stat_id, :uint32, 1
      optional :stat_value, :uint32, 2
    end
    optional :steam_id, :fixed64, 1
    optional :game_id, :fixed64, 2
    optional :crc_stats, :uint32, 3
    repeated :updated_stats, CMsgClientStatsUpdated::Updated_Stats, 4
  end

  class CMsgClientStoreUserStats

    class Stats_To_Store
      optional :stat_id, :uint32, 1
      optional :stat_value, :uint32, 2
    end
    optional :game_id, :fixed64, 1
    optional :explicit_reset, :bool, 2
    repeated :stats_to_store, CMsgClientStoreUserStats::Stats_To_Store, 3
  end

  class CMsgClientGetClientDetails
  end

  class CMsgClientReportOverlayDetourFailure
    repeated :failure_strings, :string, 1
  end

  class CMsgClientGetClientDetailsResponse

    class Game
      optional :appid, :uint32, 1
      optional :extra_info, :string, 2
      optional :time_running_sec, :uint32, 3
    end
    optional :package_version, :uint32, 1
    optional :protocol_version, :uint32, 8
    optional :os, :string, 2
    optional :machine_name, :string, 3
    optional :ip_public, :string, 4
    optional :ip_private, :string, 5
    optional :bytes_available, :uint64, 7
    repeated :games_running, CMsgClientGetClientDetailsResponse::Game, 6
  end

  class CMsgClientGetClientAppList
    optional :media, :bool, 1
    optional :tools, :bool, 2
    optional :games, :bool, 3
    optional :only_installed, :bool, 4
    optional :only_changing, :bool, 5
  end

  class CMsgClientGetClientAppListResponse

    class App

      class DLC
        optional :appid, :uint32, 1
        optional :installed, :bool, 2
      end
      optional :appid, :uint32, 1
      optional :category, :string, 2
      optional :app_type, :string, 10
      optional :favorite, :bool, 3
      optional :installed, :bool, 4
      optional :auto_update, :bool, 5
      optional :bytes_downloaded, :uint64, 6
      optional :bytes_needed, :uint64, 7
      optional :bytes_download_rate, :uint32, 8
      optional :download_paused, :bool, 11
      optional :num_downloading, :uint32, 12
      optional :num_paused, :uint32, 13
      optional :changing, :bool, 14
      optional :available_on_platform, :bool, 15
      repeated :dlcs, CMsgClientGetClientAppListResponse::App::DLC, 9
    end
    repeated :apps, CMsgClientGetClientAppListResponse::App, 1
    optional :bytes_available, :uint64, 2
  end

  class CMsgClientInstallClientApp
    optional :appid, :uint32, 1
  end

  class CMsgClientInstallClientAppResponse
    optional :result, :uint32, 1
  end

  class CMsgClientUninstallClientApp
    optional :appid, :uint32, 1
  end

  class CMsgClientUninstallClientAppResponse
    optional :result, :uint32, 1
  end

  class CMsgClientSetClientAppUpdateState
    optional :appid, :uint32, 1
    optional :update, :bool, 2
  end

  class CMsgClientSetClientAppUpdateStateResponse
    optional :result, :uint32, 1
  end

  class CMsgClientUFSUploadFileRequest
    optional :app_id, :uint32, 1
    optional :file_size, :uint32, 2
    optional :raw_file_size, :uint32, 3
    optional :sha_file, :bytes, 4
    optional :time_stamp, :uint64, 5
    optional :file_name, :string, 6
    optional :platforms_to_sync_deprecated, :uint32, 7
    optional :platforms_to_sync, :uint32, 8, :default => 4294967295
    optional :cell_id, :uint32, 9
    optional :can_encrypt, :bool, 10
  end

  class CMsgClientUFSUploadFileResponse
    optional :eresult, :int32, 1, :default => 2
    optional :sha_file, :bytes, 2
    optional :use_http, :bool, 3
    optional :http_host, :string, 4
    optional :http_url, :string, 5
    optional :kv_headers, :bytes, 6
    optional :use_https, :bool, 7
    optional :encrypt_file, :bool, 8
  end

  class CMsgClientUFSUploadCommit

    class File
      optional :eresult, :int32, 1, :default => 2
      optional :app_id, :uint32, 2
      optional :sha_file, :bytes, 3
      optional :cub_file, :uint32, 4
      optional :file_name, :string, 5
    end
    repeated :files, CMsgClientUFSUploadCommit::File, 1
  end

  class CMsgClientUFSUploadCommitResponse

    class File
      optional :eresult, :int32, 1, :default => 2
      optional :app_id, :uint32, 2
      optional :sha_file, :bytes, 3
    end
    repeated :files, CMsgClientUFSUploadCommitResponse::File, 1
  end

  class CMsgClientUFSFileChunk
    optional :sha_file, :bytes, 1
    optional :file_start, :uint32, 2
    optional :data, :bytes, 3
  end

  class CMsgClientUFSTransferHeartbeat
  end

  class CMsgClientUFSUploadFileFinished
    optional :eresult, :int32, 1, :default => 2
    optional :sha_file, :bytes, 2
  end

  class CMsgClientUFSDeleteFileRequest
    optional :app_id, :uint32, 1
    optional :file_name, :string, 2
    optional :is_explicit_delete, :bool, 3
  end

  class CMsgClientUFSDeleteFileResponse
    optional :eresult, :int32, 1, :default => 2
    optional :file_name, :string, 2
  end

  class CMsgClientUFSGetFileListForApp
    repeated :apps_to_query, :uint32, 1
    optional :send_path_prefixes, :bool, 2
  end

  class CMsgClientUFSGetFileListForAppResponse

    class File
      optional :app_id, :uint32, 1
      optional :file_name, :string, 2
      optional :sha_file, :bytes, 3
      optional :time_stamp, :uint64, 4
      optional :raw_file_size, :uint32, 5
      optional :is_explicit_delete, :bool, 6
      optional :platforms_to_sync, :uint32, 7
      optional :path_prefix_index, :uint32, 8
    end
    repeated :files, CMsgClientUFSGetFileListForAppResponse::File, 1
    repeated :path_prefixes, :string, 2
  end

  class CMsgClientUFSDownloadRequest
    optional :app_id, :uint32, 1
    optional :file_name, :string, 2
    optional :can_handle_http, :bool, 3
  end

  class CMsgClientUFSDownloadResponse
    optional :eresult, :int32, 1, :default => 2
    optional :app_id, :uint32, 2
    optional :file_size, :uint32, 3
    optional :raw_file_size, :uint32, 4
    optional :sha_file, :bytes, 5
    optional :time_stamp, :uint64, 6
    optional :is_explicit_delete, :bool, 7
    optional :use_http, :bool, 8
    optional :http_host, :string, 9
    optional :http_url, :string, 10
    optional :kv_headers, :bytes, 11
    optional :use_https, :bool, 12
    optional :encrypted, :bool, 13
  end

  class CMsgClientUFSLoginRequest
    optional :protocol_version, :uint32, 1
    optional :am_session_token, :uint64, 2
    repeated :apps, :uint32, 3
  end

  class CMsgClientUFSLoginResponse
    optional :eresult, :int32, 1, :default => 2
  end

  class CMsgClientRequestEncryptedAppTicket
    optional :app_id, :uint32, 1
    optional :userdata, :bytes, 2
  end

  class CMsgClientRequestEncryptedAppTicketResponse
    optional :app_id, :uint32, 1
    optional :eresult, :int32, 2, :default => 2
    optional :encrypted_app_ticket, EncryptedAppTicket, 3
  end

  class CMsgClientWalletInfoUpdate
    optional :has_wallet, :bool, 1
    optional :balance, :int32, 2
    optional :currency, :int32, 3
    optional :balance_delayed, :int32, 4
  end

  class CMsgClientAppInfoUpdate
    optional :last_changenumber, :uint32, 1
    optional :send_changelist, :bool, 2
  end

  class CMsgClientAppInfoChanges
    optional :current_change_number, :uint32, 1
    optional :force_full_update, :bool, 2
    repeated :appIDs, :uint32, 3
  end

  class CMsgClientAppInfoRequest

    class App
      optional :app_id, :uint32, 1
      optional :section_flags, :uint32, 2
      repeated :section_CRC, :uint32, 3
    end
    repeated :apps, CMsgClientAppInfoRequest::App, 1
    optional :supports_batches, :bool, 2, :default => false
  end

  class CMsgClientAppInfoResponse

    class App

      class Section
        optional :section_id, :uint32, 1
        optional :section_kv, :bytes, 2
      end
      optional :app_id, :uint32, 1
      optional :change_number, :uint32, 2
      repeated :sections, CMsgClientAppInfoResponse::App::Section, 3
    end
    repeated :apps, CMsgClientAppInfoResponse::App, 1
    repeated :apps_unknown, :uint32, 2
    optional :apps_pending, :uint32, 3
  end

  class CMsgClientPackageInfoRequest
    repeated :package_ids, :uint32, 1
    optional :meta_data_only, :bool, 2
  end

  class CMsgClientPackageInfoResponse

    class Package
      optional :package_id, :uint32, 1
      optional :change_number, :uint32, 2
      optional :sha, :bytes, 3
      optional :buffer, :bytes, 4
    end
    repeated :packages, CMsgClientPackageInfoResponse::Package, 1
    repeated :packages_unknown, :uint32, 2
    optional :packages_pending, :uint32, 3
  end

  class CMsgClientPICSChangesSinceRequest
    optional :since_change_number, :uint32, 1
    optional :send_app_info_changes, :bool, 2
    optional :send_package_info_changes, :bool, 3
    optional :num_app_info_cached, :uint32, 4
    optional :num_package_info_cached, :uint32, 5
  end

  class CMsgClientPICSChangesSinceResponse

    class PackageChange
      optional :packageid, :uint32, 1
      optional :change_number, :uint32, 2
      optional :needs_token, :bool, 3
    end

    class AppChange
      optional :appid, :uint32, 1
      optional :change_number, :uint32, 2
      optional :needs_token, :bool, 3
    end
    optional :current_change_number, :uint32, 1
    optional :since_change_number, :uint32, 2
    optional :force_full_update, :bool, 3
    repeated :package_changes, CMsgClientPICSChangesSinceResponse::PackageChange, 4
    repeated :app_changes, CMsgClientPICSChangesSinceResponse::AppChange, 5
    optional :force_full_app_update, :bool, 6
    optional :force_full_package_update, :bool, 7
  end

  class CMsgClientPICSProductInfoRequest

    class AppInfo
      optional :appid, :uint32, 1
      optional :access_token, :uint64, 2
      optional :only_public, :bool, 3
    end

    class PackageInfo
      optional :packageid, :uint32, 1
      optional :access_token, :uint64, 2
    end
    repeated :packages, CMsgClientPICSProductInfoRequest::PackageInfo, 1
    repeated :apps, CMsgClientPICSProductInfoRequest::AppInfo, 2
    optional :meta_data_only, :bool, 3
    optional :num_prev_failed, :uint32, 4
  end

  class CMsgClientPICSProductInfoResponse

    class AppInfo
      optional :appid, :uint32, 1
      optional :change_number, :uint32, 2
      optional :missing_token, :bool, 3
      optional :sha, :bytes, 4
      optional :buffer, :bytes, 5
      optional :only_public, :bool, 6
      optional :size, :uint32, 7
    end

    class PackageInfo
      optional :packageid, :uint32, 1
      optional :change_number, :uint32, 2
      optional :missing_token, :bool, 3
      optional :sha, :bytes, 4
      optional :buffer, :bytes, 5
      optional :size, :uint32, 6
    end
    repeated :apps, CMsgClientPICSProductInfoResponse::AppInfo, 1
    repeated :unknown_appids, :uint32, 2
    repeated :packages, CMsgClientPICSProductInfoResponse::PackageInfo, 3
    repeated :unknown_packageids, :uint32, 4
    optional :meta_data_only, :bool, 5
    optional :response_pending, :bool, 6
    optional :http_min_size, :uint32, 7
    optional :http_host, :string, 8
  end

  class CMsgClientPICSAccessTokenRequest
    repeated :packageids, :uint32, 1
    repeated :appids, :uint32, 2
  end

  class CMsgClientPICSAccessTokenResponse

    class PackageToken
      optional :packageid, :uint32, 1
      optional :access_token, :uint64, 2
    end

    class AppToken
      optional :appid, :uint32, 1
      optional :access_token, :uint64, 2
    end
    repeated :package_access_tokens, CMsgClientPICSAccessTokenResponse::PackageToken, 1
    repeated :package_denied_tokens, :uint32, 2
    repeated :app_access_tokens, CMsgClientPICSAccessTokenResponse::AppToken, 3
    repeated :app_denied_tokens, :uint32, 4
  end

  class CMsgClientUFSGetUGCDetails
    optional :hcontent, :fixed64, 1, :default => 18446744073709551615
  end

  class CMsgClientUFSGetUGCDetailsResponse
    optional :eresult, :int32, 1, :default => 2
    optional :url, :string, 2
    optional :app_id, :uint32, 3
    optional :filename, :string, 4
    optional :steamid_creator, :fixed64, 5
    optional :file_size, :uint32, 6
    optional :compressed_file_size, :uint32, 7
    optional :rangecheck_host, :string, 8
    optional :file_encoded_sha1, :string, 9
  end

  class CMsgClientUFSGetSingleFileInfo
    optional :app_id, :uint32, 1
    optional :file_name, :string, 2
  end

  class CMsgClientUFSGetSingleFileInfoResponse
    optional :eresult, :int32, 1, :default => 2
    optional :app_id, :uint32, 2
    optional :file_name, :string, 3
    optional :sha_file, :bytes, 4
    optional :time_stamp, :uint64, 5
    optional :raw_file_size, :uint32, 6
    optional :is_explicit_delete, :bool, 7
  end

  class CMsgClientUFSShareFile
    optional :app_id, :uint32, 1
    optional :file_name, :string, 2
  end

  class CMsgClientUFSShareFileResponse
    optional :eresult, :int32, 1, :default => 2
    optional :hcontent, :fixed64, 2, :default => 18446744073709551615
  end

  class CMsgClientNewLoginKey
    optional :unique_id, :uint32, 1
    optional :login_key, :string, 2
  end

  class CMsgClientNewLoginKeyAccepted
    optional :unique_id, :uint32, 1
  end

  class CMsgClientAMGetClanOfficers
    optional :steamid_clan, :fixed64, 1
  end

  class CMsgClientAMGetClanOfficersResponse
    optional :eresult, :int32, 1, :default => 2
    optional :steamid_clan, :fixed64, 2
    optional :officer_count, :int32, 3
  end

  class CMsgClientAMGetPersonaNameHistory

    class IdInstance
      optional :steamid, :fixed64, 1
    end
    optional :id_count, :int32, 1
    repeated :Ids, CMsgClientAMGetPersonaNameHistory::IdInstance, 2
  end

  class CMsgClientAMGetPersonaNameHistoryResponse

    class NameTableInstance

      class NameInstance
        optional :name_since, :fixed32, 1
        optional :name, :string, 2
      end
      optional :eresult, :int32, 1, :default => 2
      optional :steamid, :fixed64, 2
      repeated :names, CMsgClientAMGetPersonaNameHistoryResponse::NameTableInstance::NameInstance, 3
    end
    repeated :responses, CMsgClientAMGetPersonaNameHistoryResponse::NameTableInstance, 2
  end

  class CMsgClientDeregisterWithServer
    optional :eservertype, :uint32, 1
    optional :app_id, :uint32, 2
  end

  class CMsgClientClanState

    class NameInfo
      optional :clan_name, :string, 1
      optional :sha_avatar, :bytes, 2
    end

    class UserCounts
      optional :members, :uint32, 1
      optional :online, :uint32, 2
      optional :chatting, :uint32, 3
      optional :in_game, :uint32, 4
    end

    class Event
      optional :gid, :fixed64, 1
      optional :event_time, :uint32, 2
      optional :headline, :string, 3
      optional :game_id, :fixed64, 4
      optional :just_posted, :bool, 5
    end
    optional :steamid_clan, :fixed64, 1
    optional :m_unStatusFlags, :uint32, 2
    optional :clan_account_flags, :uint32, 3
    optional :name_info, CMsgClientClanState::NameInfo, 4
    optional :user_counts, CMsgClientClanState::UserCounts, 5
    repeated :events, CMsgClientClanState::Event, 6
    repeated :announcements, CMsgClientClanState::Event, 7
  end

  class CMsgClientFriendMsg
    optional :steamid, :fixed64, 1
    optional :chat_entry_type, :int32, 2
    optional :message, :bytes, 3
    optional :rtime32_server_timestamp, :fixed32, 4
  end

  class CMsgClientFriendMsgIncoming
    optional :steamid_from, :fixed64, 1
    optional :chat_entry_type, :int32, 2
    optional :from_limited_account, :bool, 3
    optional :message, :bytes, 4
    optional :rtime32_server_timestamp, :fixed32, 5
  end

  class CMsgClientAddFriend
    optional :steamid_to_add, :fixed64, 1
    optional :accountname_or_email_to_add, :string, 2
  end

  class CMsgClientAddFriendResponse
    optional :eresult, :int32, 1, :default => 2
    optional :steam_id_added, :fixed64, 2
    optional :persona_name_added, :string, 3
  end

  class CMsgClientRemoveFriend
    optional :friendid, :fixed64, 1
  end

  class CMsgClientHideFriend
    optional :friendid, :fixed64, 1
    optional :hide, :bool, 2
  end
end
